import * as tapable from "tapable";
import { Callback } from "tapable";
import * as binding from "@rspack/binding";
import { Logger } from "./logging/Logger";
import type { Watch } from "./config/watch";
import { RspackOptionsNormalized } from "./config";
import { Stats } from "./stats";
import { Compilation } from "./compilation";
declare class Compiler {
    #private;
    webpack: any;
    compilation: Compilation;
    infrastructureLogger: any;
    outputPath: string;
    name: string;
    inputFileSystem: any;
    outputFileSystem: any;
    hooks: {
        done: tapable.AsyncSeriesHook<Stats>;
        afterDone: tapable.SyncHook<Stats>;
        compilation: tapable.SyncHook<Compilation>;
        thisCompilation: tapable.SyncHook<[Compilation]>;
        invalid: tapable.SyncHook<[string | null, number]>;
        compile: tapable.SyncHook<[any]>;
        initialize: tapable.SyncHook<[]>;
        infrastructureLog: tapable.SyncBailHook<[string, string, any[]], true>;
        beforeRun: tapable.AsyncSeriesHook<[Compiler]>;
        run: tapable.AsyncSeriesHook<[Compiler]>;
        failed: tapable.SyncHook<[Error]>;
    };
    options: RspackOptionsNormalized;
    constructor(context: string, options: RspackOptionsNormalized);
    getInfrastructureLogger(name: string | Function): Logger;
    run(callback: any): void;
    build(cb: Callback<Error, binding.StatsCompilation>): void;
    rebuild(changedFiles: string[], cb: (error?: Error, stats?: {
        diff: binding.DiffStat;
        stats: binding.StatsCompilation;
    }) => void): void;
    watch(watchOptions?: Watch, ws?: any): Promise<Watching>;
    purgeInputFileSystem(): void;
    /**
     * @todo
     */
    close(callback: any): void;
    emitAssets(compilation: Compilation, callback: any): void;
}
export interface Watching {
    close(): Promise<void>;
}
export { Compiler };
//# sourceMappingURL=compiler.d.ts.map