"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveEntryOptions = void 0;
const path_1 = __importDefault(require("path"));
function resolveEntryOptions(options, context) {
    if (typeof options === "undefined" || options === null) {
        return {
            main: [path_1.default.resolve(context.context, "src", "index.js")]
        };
    }
    else if (typeof options === "string") {
        return {
            main: [options]
        };
    }
    else if (Array.isArray(options)) {
        return {
            main: [...options]
        };
    }
    else if (typeof options === "object") {
        return Object.fromEntries(Object.entries({ ...options }).map(([key, value]) => {
            if (Array.isArray(value)) {
                return [key, [...value]];
            }
            else {
                return [key, [value]];
            }
        }));
    }
    else {
        return {};
    }
}
exports.resolveEntryOptions = resolveEntryOptions;
//# sourceMappingURL=entry.js.map