import type { Context, ResolvedContext } from "./context";
import type { Dev } from "./devServer";
import type { Entry, ResolvedEntry } from "./entry";
import type { External, ExternalType, ResolvedExternal, ResolvedExternalType } from "./external";
import type { Mode, ResolvedMode } from "./mode";
import type { Module, ResolvedModule, LoaderContext } from "./module";
import type { Plugin } from "./plugin";
import type { ResolvedTarget, Target } from "./target";
import type { Output, ResolvedOutput } from "./output";
import type { Resolve, ResolvedResolve } from "./resolve";
import type { Builtins, ResolvedBuiltins } from "./builtins";
import { Devtool, ResolvedDevtool } from "./devtool";
import { InfrastructureLogging } from "./RspackOptions";
import { ResolvedStatsOptions, StatsOptions } from "./stats";
export declare type Configuration = RspackOptions;
export interface RspackOptions {
    name?: string;
    entry?: Entry;
    context?: Context;
    plugins?: Plugin[];
    devServer?: Dev;
    module?: Module;
    target?: Target;
    mode?: Mode;
    externals?: External;
    externalsType?: ExternalType;
    output?: Output;
    builtins?: Builtins;
    resolve?: Resolve;
    devtool?: Devtool;
    infrastructureLogging?: InfrastructureLogging;
    stats?: StatsOptions;
}
export interface RspackOptionsNormalized {
    name?: string;
    entry: ResolvedEntry;
    context: ResolvedContext;
    plugins: Plugin[];
    devServer?: Dev;
    module: ResolvedModule;
    target: ResolvedTarget;
    mode: ResolvedMode;
    externals: ResolvedExternal;
    externalsType: ResolvedExternalType;
    output: ResolvedOutput;
    builtins: ResolvedBuiltins;
    resolve: ResolvedResolve;
    devtool: ResolvedDevtool;
    infrastructureLogging: InfrastructureLogging;
    stats: ResolvedStatsOptions;
}
export declare function getNormalizedRspackOptions(config: RspackOptions): RspackOptionsNormalized;
export type { Plugin, LoaderContext };
export type { WebSocketServerOptions, Dev } from "./devServer";
export { resolveWatchOption } from "./watch";
export type { StatsOptions } from "./stats";
//# sourceMappingURL=index.d.ts.map