"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveWatchOption = exports.getNormalizedRspackOptions = void 0;
const entry_1 = require("./entry");
const devtool_1 = require("./devtool");
const target_1 = require("./target");
const output_1 = require("./output");
const module_1 = require("./module");
const builtins_1 = require("./builtins");
const resolve_1 = require("./resolve");
const stats_1 = require("./stats");
function getNormalizedRspackOptions(config) {
    var _a, _b, _c, _d, _e;
    const context = (_a = config.context) !== null && _a !== void 0 ? _a : process.cwd();
    const mode = (_b = config.mode) !== null && _b !== void 0 ? _b : "production";
    const entry = (0, entry_1.resolveEntryOptions)(config.entry, {
        context
    });
    const output = (0, output_1.resolveOutputOptions)(config.output);
    const target = (0, target_1.resolveTargetOptions)(config.target);
    const externals = (_c = config.externals) !== null && _c !== void 0 ? _c : {};
    const externalsType = (_d = config.externalsType) !== null && _d !== void 0 ? _d : "";
    const plugins = (_e = config.plugins) !== null && _e !== void 0 ? _e : [];
    const builtins = (0, builtins_1.resolveBuiltinsOptions)(config.builtins || {}, context);
    const resolve = (0, resolve_1.resolveResolveOptions)(config.resolve, { target });
    const devtool = (0, devtool_1.resolveDevtoolOptions)(config.devtool);
    const module = (0, module_1.resolveModuleOptions)(config.module, { devtool, context });
    const stats = (0, stats_1.resolveStatsOptions)(config.stats);
    const devServer = config.devServer;
    return {
        ...config,
        context,
        mode,
        devServer,
        entry,
        output,
        target,
        externals,
        externalsType,
        plugins,
        builtins,
        module,
        resolve,
        devtool,
        infrastructureLogging: cloneObject(config.infrastructureLogging),
        stats
    };
}
exports.getNormalizedRspackOptions = getNormalizedRspackOptions;
function cloneObject(value) {
    return { ...value };
}
var watch_1 = require("./watch");
Object.defineProperty(exports, "resolveWatchOption", { enumerable: true, get: function () { return watch_1.resolveWatchOption; } });
//# sourceMappingURL=index.js.map